Skip to content

HPE Greenlake for File Storage REST APIs (1.0.0)

HPE Greenlake for File Storage REST APIs

Download OpenAPI description
Languages
Servers
https://eu1.data.cloud.hpe.com/
https://us1.data.cloud.hpe.com/
https://jp1.data.cloud.hpe.com/
Mock server
https://developer.greenlake.hpe.com/_mock/docs/greenlake/services/file-storage/public/openapi/file-storage-public-v1alpha1/file-storage-api/

file-shares

Refers to a collection of file shares. A file share is a specific folder in a filesystem. It includes that folder's subfolders, which can be made accessible to clients via protocols like NFS and SMB.

Operations

file-systems

Refers to a collection of filesystems.

Operations

Get all filesystems on a HPE Alletra Storage X10000 system

Request

Security
bearer
Path
systemIdstringrequired

systemId of the storage system

Query
limitinteger[ 0 .. 5000 ]

Number of items to return at a time

Default 100
Example: limit=10
offsetinteger[ 0 .. 100000 ]

The offset of the first item in the collection to return

Default 0
Example: offset=5
selectstring

Query to select only the required parameters, separated by . if nested

Example: select=id
filterstring

The expression to use for filtering responses.

Filtering is supported on the below properties:

  • state
  • name
  • id
  • shareCount
  • hardLimitInBytes
  • softLimitInBytes
Example: filter=GET /file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems?filter=name eq "fs1"
sortstring<= 50 characters

A comma separated list of properties to sort by, followed by a direction indicator ("asc" or "desc"). If no direction indicator is specified the default order is ascending. Sorting is supported for the following attributes:

  • state
  • name
  • shareCount
  • createdAt
  • updatedAt
  • hardLimitInBytes
  • softLimitInBytes Example: GET /file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems?sort=name desc
Default "name asc"
Example: sort=id desc
curl -i -X GET \
  'https://eu1.data.cloud.hpe.com/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Success

Bodyapplication/json
countintegerrequired

Number of items in this response.

offsetintegerrequired

The offset query parameter from the request.

itemsArray of objects(HomefleetFilesystem)required
items[].​idstring(uuid)required

Unique identifier of the Filesystem

items[].​typestringread-onlyrequired

The type of resource.

items[].​commonResourceAttributesobject(fileCommonResourceAttributes)
items[].​createdAtobject

Creation time

items[].​customerIdstring

The identifier of the customer application

items[].​generationinteger(int64)read-only

A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.

items[].​hardLimitInBytesinteger

Specifies the hard limit for the filesystem quota

items[].​namestring

Filesystem name

Example: "FS1"
items[].​resourceUristring

Resource URI of the filesystem

items[].​shareCountinteger

Number of file-shares created on the filesystem

items[].​statestring

Filesystem state

Example: "NORMAL"
items[].​systemIdstring

SystemUid or serial number of the array.

Example: "7CE751P312"
items[].​systemWwnstring

WWN of Storage System

Example: "7CE751P312"
items[].​updatedAtobject

Update time

totalinteger

Total number of items matching the filter parameter in the request.

Response
application/json
{ "count": 0, "items": [ { … } ], "offset": 0, "total": 0 }

Delete a filesystem on a HPE Alletra Storage X10000 system

Request

This API endpoint deletes the specified filesystem on a HPE Alletra Storage X10000 system.

Security
bearer
Path
systemIdstringrequired

systemId of the storage system

filesystemIdstringrequired

Unique identifier of the filesystem

curl -i -X DELETE \
  'https://eu1.data.cloud.hpe.com/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Accepted

Headers
Locationstring

This contains the URI of the task used to monitor the request

Bodyapplication/json
taskUristringrequired

Task URI which can be used to monitor the status of the operation.

Example: "/rest/vega/v1/tasks/4969a568-6fed-4915-bcd5-e4566a75e00c"
messagestring

The task message

Example: "Successfully submitted"
statusstring

Status of the task

Example: "SUBMITTED"
Response
application/json
{ "message": "Successfully submitted", "status": "SUBMITTED", "taskUri": "/rest/vega/v1/tasks/4969a568-6fed-4915-bcd5-e4566a75e00c" }

Get a specific filesystem

Request

Security
bearer
Path
systemIdstringrequired

SystemUid/Serial Number of the array

filesystemIdstringrequired

Unique identifier of the filesystem

curl -i -X GET \
  'https://eu1.data.cloud.hpe.com/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Success

Bodyapplication/json
idstring(uuid)required

Unique identifier of the Filesystem

typestringread-onlyrequired

The type of resource.

filesystemCapacityobject(HomefleetFilesystemCapacity)
filesystemPerformanceobject(HomefleetFilesystemPerformance)
commonResourceAttributesobject(fileCommonResourceAttributes)
createdAtobject

Creation time

customerIdstring

The identifier of the customer application

generationinteger(int64)read-only

A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.

hardLimitInBytesinteger

Specifies the hard limit for the filesystem quota

namestring

Filesystem name

Example: "FS1"
resourceUristring

Resource URI of the filesystem

shareCountinteger

Number of file-shares created on the filesystem

statestring

Filesystem state

Example: "NORMAL"
systemIdstring

SystemUid or serial number of the array.

Example: "7CE751P312"
systemWwnstring

WWN of Storage System

Example: "7CE751P312"
updatedAtobject

Update time

Response
application/json
{ "filesystemCapacity": { "compressionRatio": 0, "compressionSavings": 0, "logicalUsage": 301752.345342, "physicalUsage": 3252.2370367, "totalInodes": 0 }, "filesystemPerformance": { "readIops": 750.2, "readLatencyMs": 12.8, "readMdLatencyMs": 12.8, "readThroughputKbps": 5120.4, "totalIops": 1250.5, "totalLatencyMs": 15.2, "totalMdLatencyMs": 15.2, "totalThroughputKbps": 8192.7, "writeIops": 500.3, "writeLatencyMs": 18.6, "writeMdLatencyMs": 18.6, "writeThroughputKbps": 3072.3 }, "commonResourceAttributes": { "cloudState": "CONNECTED", "errCode": "string", "errMessage": "string" }, "createdAt": { "ms": 0, "tz": "string" }, "customerId": "string", "generation": 0, "hardLimitInBytes": 0, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "name": "FS1", "resourceUri": "string", "shareCount": 0, "state": "NORMAL", "systemId": "7CE751P312", "systemWwn": "7CE751P312", "type": "string", "updatedAt": { "ms": 0, "tz": "string" } }

Get filesystem capacity trend data of a Filesystem identified by {filesystemId} on a HPE Alletra Storage X10000 system

Request

Retrieves historical capacity metrics for the filesystem identified by {filesystemId} on an HPE Alletra Storage X10000 system. Use the select, range, and timeintervalmin query parameters to refine the request.

Security
bearer
Path
systemIdstringrequired

SystemUid/Serial Number of the array

filesystemIdstringrequired

Unique identifier of the filesystem

Query
selectstring

Query to select only the required parameters, separated by . if nested

Example: select=id
rangestring

Defines the start and end time for the query.

Example: range=startTime eq 1605063600 and endTime eq 1605186000
timeintervalmininteger

It defines granularity in minutes.

Enum5601440
Example: timeintervalmin=60
curl -i -X GET \
  'https://eu1.data.cloud.hpe.com/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}/capacity-history' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Success

Bodyapplication/json
itemsArray of objects or null(DeviceType7FilesystemCapacityHistory)required
items[].​typestringrequired

The type of resource.

Example: "string"
items[].​idstringrequired

Unique identifier of the filesystem

items[].​capacityDataobject or null
items[].​commonResourceAttributesobject(fileCommonResourceAttributes)
items[].​customerIdstring

The identifier of the customer application

Example: "string"
items[].​endTimeinteger or null

End time of the capacity history

Example: 1625209133
items[].​startTimeinteger or null

Start time of the capacity history

Example: 1625122733
items[].​systemIdstring

SystemUid or serial number of the array

Example: "HFLANBROR6"
countintegerrequired

Number of items in this response

offsetinteger

The offset query parameter from the request

totalinteger

Total number of items matching the filter parameter in the request

Response
application/json
{ "count": 0, "items": [ { … } ], "offset": 0, "total": 0 }

Get performance trend data of a filesystem identified by {filesystemId} on a HPE Alletra Storage X10000 system

Request

Retrieves historical performance metrics for the filesystem identified by {filesystemId} on an HPE Alletra Storage X10000 system. Use the select, range, and timeintervalmin query parameters to refine the request.

Security
bearer
Path
systemIdstringrequired

systemId of the storage system

filesystemIdstringrequired

Unique identifier of the filesystem

Query
selectstring

Query to select only the required parameters, separated by . if nested

Example: select=id
rangestring

Defines the start and end time for the query.

Example: range=startTime eq 1605063600 and endTime eq 1605186000
timeintervalmininteger

It defines granularity in minutes.

Enum5601440
Example: timeintervalmin=60
curl -i -X GET \
  'https://eu1.data.cloud.hpe.com/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}/performance-history' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Success

Bodyapplication/json
itemsArray of objects or null(DeviceType7FilesystemPerformanceHistory)required
items[].​typestringrequired

The type of resource.

Example: "string"
items[].​idstringrequired

Unique identifier of the filesystem

items[].​commonResourceAttributesobject(fileCommonResourceAttributes)
items[].​customerIdstring

The identifier of the customer application

Example: "fc5f41652a53497e88cdcebc715cc1cf"
items[].​endTimeinteger

End time of history data

Example: 162564271
items[].​historyDataobject or null
items[].​startTimeinteger

Start time of history data

Example: 1625556314
items[].​systemIdstring

SystemUid or serial number of the array

Example: "HFLANBROR6"
countintegerrequired

Number of items in this response

offsetinteger

The offset query parameter from the request

totalinteger

Total number of items matching the filter parameter in the request

Response
application/json
{ "count": 0, "items": [ { … } ], "offset": 0, "total": 0 }

fileshare-settings

File share settings APIs

Operations

fileshares

Refers to a collection of file shares. A file share is a specific folder in a filesystem. It includes that folder's subfolders, which can be made accessible to clients via protocols like NFS and SMB.

Operations

filesystems

Refers to a collection of filesystems.

Operations